#include "seg_ext.h"
#ifdef LATER
do_get_thresh(argc,argv) 
int 	argc;
char 	**argv;
{
Element 	*element;
Element 	*parent;
Buffer		*buffer;
int 		nxtarg;
char		*buffer_name;

    if(argc < 4){
	printf("usage: %s parent buffer mode ...\n",argv[0]);
    }
    /*
    ** parent element
    */
    parent = GetElement(argv[1]);
    buffer_name = argv[2];

    if (trace >0){
	printf ("GetThresh %d\n",argv[1]);
    }

    nxtarg = 3;
    if(arg_is("DEFINE ALL")){
	for(element=parent->child;element;element=element->next){
	    if(buffer = GetBuffer(element,buffer_name)){ 
		if( buffer->type && strcmp(buffer->type,"spike_type") == 0){
		    Specific(buffer,spike_type,thresh) = farg();
		} else {
		    Warning();
		    printf("buffer must be a 'spike_type' to set thresholds\n");
		}
	    }
	}
    } else
    /*
    * generate a random distribution of thresholds?
    */
    if(arg_is("RANDOM")){
	if(nxtarg + 1 >= argc){
	    Error();
	    printf ("Error in threshold specification");
	    return(0);
	}
	/*
	* normally distributed?
	*/
	nxtarg++;
	if(arg_is("NORMAL")){
	    float u,s;
	    u = farg();
	    s = farg();
	    for(element=parent->child;element;element=element->next){
		if(buffer = GetBuffer(element,buffer_name)){
		    if( buffer->type && strcmp(buffer->type,"spike_type") == 0){
			Specific(buffer,spike_type,thresh) = rangauss(u,s);
		    } else {
			Warning();
			printf("buffer must be a 'spike_type' to set thresholds\n");
		    }
		}
	    }
	} else
	/*
	* or uniformly distributed
	*/
	if(arg_is("UNIFORM")){
	    float	upper_thr;
	    float	lower_thr;
	    upper_thr = farg();
	    lower_thr = farg();
	    for(element=parent->child;element;element=element->next){
		if(buffer = GetBuffer(element,buffer_name)){
		    if( buffer->type && strcmp(buffer->type,"spike_type") == 0){
			Specific(buffer,spike_type,thresh) = 
			frandom(lower_thr,upper_thr);
		    } else {
			Warning();
			printf("buffer must be a 'spike_type' to set thresholds\n");
		    }
		}
	    }
	} else {
	    Error();
	    printf ("Error in threshold specification");
	    return(0);
	}
    } else {
	Error();
	printf ("Error in threshold specification");
	return(0);
    }
}

#endif
