#include "seg_ext.h"

int	DEBUG_RC_Unit = 0;

/* 10/88 Matt Wilson */
RC_Unit(unit,action)
struct RCunit_type 	*unit;
Action			*action;
{
MsgIn				*msg;
double				A;

    if(Debug(DEBUG_RC_Unit) > 1){
	ActionHeader("RC_Unit",unit,action);
    }
    switch(action->type){
    case PROCESS:
	A = unit->inject + unit->V0/unit->R;
	for(msg=unit->msg_in;msg;msg=msg->next){
	    /*
	    ** type 0 : current injection
	    **    0 = Ik
	    */
	    A += MsgValue(msg,double,0);
	}
	/*
	** INTEGRATION
	*/
	unit->state = 
	IntegrateMethod(unit->method, unit,unit->state,
	A/unit->C,1/(unit->R*unit->C),
	Clockrate(unit),"Ustate");
	break;
    case RESET:
	unit->state = unit->V0;
	break;
    case CHECK:
	/*
	** check RC to insure it is non-zero
	*/
	if(unit->R <= 0.0 || unit->C <= 0.0){
	    ErrorMessage("RC_Unit","Invalid RC time constant",unit);
	}
	break;
    }
}
